SetFactory("OpenCASCADE");
pcb_model() = ShapeFromFile(".\testing\step-models\trace.step");
//pcb_model() = ShapeFromFile(".\testing\step-models\single-diffpair-2layer.step");
//Merge ".\testing\step-models\single-diffpair-2layer.step";
//pcb_model() = Volume{:};

//Mesh.Algorithm = 5;
//Mesh.MeshSizeMax = 0.05;

bbox() = BoundingBox Volume{pcb_model()};

xmin = bbox(0);
ymin = bbox(1);
zmin = bbox(2);
xmax = bbox(3);
ymax = bbox(4);
zmax = bbox(5);

// mm height above and below PCB
air_height = 2;
// Box(1000) = {xmin, ymin, (zmin - air_height), (xmax - xmin), (ymax - ymin), (zmax - zmin + (air_height * 2))};


Physical Volume("Board")    = {};
Physical Volume("Copper")   = {};

/* For trace test */
Physical Surface("voltage", 37) = {8};
Physical Surface("load", 38) = {10};


For i In {0: #pcb_model()-1}
    name = Str(Volume{pcb_model(i)});
    If(StrFind(name, "Core"))
        Physical Volume("Board") += pcb_model(i);
        Printf("board~");
    Else
        Physical Volume("Copper") += pcb_model(i);
        Printf("copper~");
    EndIf
EndFor

Coherence;

pcb_curves() = Curve In BoundingBox {xmin, ymin, zmin, xmax, ymax, zmax};

Field[1] = Distance;
Field[1].CurvesList = {pcb_curves()};
Field[1].Sampling = 100;

Field[2] = Threshold;
Field[2].InField = 1;
Field[2].SizeMin = 0.05;
Field[2].SizeMax = 1.0;
Field[2].DistMin = 0.1;
Field[2].DistMax = 2.0;

Field[3] = Min;
Field[3].FieldsList = {2};
Background Field = 3;

Mesh.MeshSizeExtendFromBoundary = 0;
Mesh.MeshSizeFromPoints = 0;
Mesh.MeshSizeFromCurvature = 0;

Mesh.Algorithm = 5;
